<?php
// $Id: taxonomy_treemenu.admin.inc,v 1.6 2009/04/01 14:32:07 rcrowther Exp $


function taxonomy_treemenu_menu_update_submit($form, &$form_state) {
  $menu = $form_state['values'];
  //dpm($menu);
  $targets = array();
  foreach ($menu['targets'] as $target ) {
    if ($target != '') {
      $targets[] = $target;
      taxonomy_treemenu_rebuild($target);    
    }
  }
  //dpm($targets);
  $menus = implode(', ', $targets);
  $t_args = array('%menus' => $menus);
  drupal_set_message(t('The treemenu(s) %menus has been rebuilt', $t_args));
  $form_state['redirect'] = $menu['destination'];  
}

function taxonomy_treemenu_menu_update_validate($form, &$form_state) {
  $checked = FALSE;
  foreach ($form_state['values']['targets'] as $target) {
  //dpm($target);
    if (!empty($target)) {$checked = TRUE;}
  }
  //dpm('checked: ');
  //dvm( $checked);
  if (!$checked) {
    form_set_error('targets', t("Please choose at least one menu!"));    
  }
}

function taxonomy_treemenu_menu_update($form_state) {
  $form = array();
  $options = array();

  $tmd = variable_get('taxonomy_treemenu_data', array());
  foreach ($tmd as $menu_name => $value) {
    $options[$menu_name] = substr($menu_name ,strpos('-', $menu_name));
  }

  //we dont want the persistancy of a drupal warning message, but we do want it's immediacy, so we steal the css class.
  $form['message'] = array(
    '#value' => "<div class='messages warning'>" . t("Treemenus should update automatically. This form provides some disaster recovery. If subnitted, this form rebuilds the checked menu(s) completely and, in the worst case, will delete and rebuild all links. This may not be the problem - try emptying Drupal and browser caches, or a menu rebuild, first.") . "</div>",
  );
  
  $form['targets'] = array(
    '#type' => 'checkboxes',
    '#options' => $options,
    '#default value' => '',
    '#description' => t('Perform a full update on any treemenu individually.'),
  );
  
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Rebuild'),
  );
  $form['back'] = array(
  '#type' => 'value',
  '#value' => $_GET['destination'],
  );
  //dpm($_GET['destination']);
  //dpm($form_state);
  return $form;
}

/**
 * Function for generating a set of options for selecting a branch from the taxonomy.
 * Not the same options or keys as taxonomy_form_all()
 */
function taxonomy_treemenu_form_all($free_tags = 0) {
  $vocabularies = taxonomy_get_vocabularies();
  $options = array();
  $options['-:-'] = t('choose a branch here');
  foreach ($vocabularies as $vid => $vocabulary) {
    if ($vocabulary->tags && !$free_tags) { continue; }
    $vocab_path = $vid . ':';
    $options[$vocab_path . '0'] = $vocabulary->name . ' (vocab)';
    $tree = taxonomy_get_tree($vid);
    if ($tree && (count($tree) > 0)) {
    
      //$options[$vocabulary->name] = array();
      foreach ($tree as $term) {
        $options[$vocab_path . $term->tid] = str_repeat('-', $term->depth + 1) . $term->name;
        //$options[$vocabulary->name][$term->tid] = str_repeat('-', $term->depth) . $term->name;
      }
    }
  }
  return $options;
}

/**
 * Use the stock form-element theme..
 */
function theme_branch_selector_by_option($element) {
  return theme('form_element', $element, $element['#children']);
}

function theme_branch_selector_by_gui($element) {
  drupal_add_js(drupal_get_path('module', 'taxonomy_treemenu') .'/taxonomy_treemenu.js');
  return theme('form_element', $element, $element['#children']);
}


function theme_taxonomy_admin_js_link($title, $id) {
//edit-tree-root-data
  return "<a href='#' onclick=\"updateTargetBranch('" . $id . "')\">" . check_plain(trim($title)) . "</a>";
}

function taxonomy_treemenu_taxonomy_tree_output() {
  $output = '';
  $items = taxonomy_treemenu_form_all();
  foreach($items as $id => $title) {
    $link = theme('taxonomy_admin_js_link', $title, $id);
    //dpm($link);
    $output .= theme('menu_item', $link, FALSE);
  }
  return $output ? theme('menu_tree', $output) : '';
}

function taxonomy_treemenu_taxonomy_full_admin_js_tree() {
  //static $taxonomy_treemenu_js_tree_output = array();
  //if (!isset($taxonomy_treemenu_js_tree_output)) {
    $taxonomy_treemenu_js_tree_output = taxonomy_treemenu_taxonomy_tree_output();
  //}
  return $taxonomy_treemenu_js_tree_output;
}

/**
 * Generate a gui for selecting a branch, returning the path.
 */
 //now, the way we've done this, we do not have a full menu to call,
 //and Durpal doesn't supply one (which is why we are here in the first place)
 //Making a menu is kind of hard as a one off,
 //but a list should be possible by Drupal methods...
function expand_branch_selector_by_gui($element) {
  $element['tree_root_data'] = array(
    '#type' => 'hidden',
    '#default_value' => '-:-',
  );

  //Includes stolen CSS to make a 'required' asterix.
  // (we can't do that properly, as this selector uses a hidden field)
  //The result is real enough, as we do validate for value existance.
  $element['selector_display'] = array(
    '#prefix' => "<div><b>Select Branch:&nbsp</b>&nbsp<b>vocabulary:&nbsp</b><span id='branch-selector-display-vid'>no choice made</span>&nbsp<b>term:&nbsp</b><span id='branch-selector-display-tid'>no choice made</span><span class=\"form-required\">&nbsp*</span></div>",
    '#value' => taxonomy_treemenu_taxonomy_full_admin_js_tree(),
  );

  $element['#tree'] = TRUE;
  return $element;
}

/**
 * Generate a set of options for selecting a branch, returning the path.
 */
function expand_branch_selector_by_option($elements, $form_values) {
  $options = array();
  $paths = array();

  //get titles and info
  //$options['choose a branch here'] = taxonomy_treemenu_form_all();
  $options = taxonomy_treemenu_form_all();

  $elements['#type'] = 'select';
  $elements['#title'] = t('Select Branch');
  $elements['#default_value'] = '-:-';
  $elements['#options'] = $options;
  //$elements['#description'] = t("On submiting, the chosen branch (and sub-branches, depending on the 'depth' setting) are turned into a custom menu.");
  return $elements;
}


function theme_depth($element) {
  return theme('form_element', $element, $element['#children']);
}

function expand_depth_selector($elements, $form_values) {
  $options = array('full depth');
  for ($i = 1; $i < 9; $i++) {
    $options[] = $i;
  }
  $elements['#type'] = 'select';
  $elements['#options'] = $options;  
  return $elements;
}


//strangely, they need explicit declaration of theme
//documentation says they don't,
//Drupal knows they are there, as they bail out without one
//but they are not called automatically...
function taxonomy_treemenu_elements() {
  $type = array();
  $type['branch_selector_by_gui'] = array('#input' => TRUE, '#process' => array('expand_branch_selector_by_gui') );
  $type['branch_selector_by_option'] = array('#input' => TRUE, '#process' => array('expand_branch_selector_by_option') );
  $type['depth'] = array('#input' => TRUE, '#process' => array('expand_depth_selector'));
  return $type;
}


function taxonomy_treemenu_form_branch_selector() {    
  $branch_selector_type = variable_get('taxonomy_treemenu_selector_is_gui', FALSE);

  $selector['branch_selector'] = array(
    '#type' => 'fieldset',
    '#title' => t('Branch selector'),
    '#collapsible' => FALSE,
    '#description' => t("On submitting, the chosen branch (and sub-branches, depending on the 'depth' setting) are turned into a custom menu."),
    '#required' => TRUE,
  );

  $sector_submit_label = 'toggle branch selector to ';
  $sector_submit_label .= ($branch_selector_type) ? 'gui' : 'option list';  
  $selector['branch_selector']['change_selector'] = array(
    '#type' => 'submit',
    '#value' => $sector_submit_label,
    '#validate' => array('taxonomy_treemenu_edit_menu_change_selector'),
  );
  
  if (variable_get('taxonomy_treemenu_selector_is_gui', FALSE)) {
 	  $selector['branch_selector']['tree_root_data'] = array('#type' => 'branch_selector_by_option', '#required' => TRUE);
  }
  else {
    $selector['branch_selector']['tree_root_display'] = array('#type' => 'branch_selector_by_gui', '#required' => TRUE);       
  }
 
  return $selector;
}



//should really use double submit, as i'm not sure this would run validate functions, etc.
//pulled in the edit form, rather than altering it,
// allows us to put the function in a separate file
// but does it run proper validate funtions and so forth?
// and not really compatible with 'edit' function in hook_alter().
// Yeah, but it works and its callable from a seperate file.
// Can't be called with an invalid menu_name, as we set these ourselves in the hook_menu.
//but we use out hook_load anyway. Will protect future code.
function taxonomy_treemenu_edit_menu($form_state, $type, $menu_name = '') {
  //dpm($menu_name);
  $form = array();
  $treemenu = array();

  if ($type == 'add') {
    //set defaults, replace branch selector with a value.
    $treemenu = array(
      'vid'   => 0,
      'tid'   => 0,
      'depth' => 0,
      'nodes' => 0,
      'leaf_node_count' => 1,
      'link_roots_to_menutrees' => 1,
      //'root_path' => '<root>',
      //'disable_treemenu_links'  => 'disabled',
      //'enable_root_links'       => 1,
      //'enable_tree_leaves'      => 1,
      'title' => 'New menu', 
    );
    $form = taxonomy_treemenu_form_branch_selector();
    //will be done automatically by the require, I think, but lets assert it.
    $form['#insert'] = TRUE;
  }
  else {
    //get current data, display useful values
    if(!$treemenu = taxonomy_treemenu_load($menu_name, TRUE)) {
      drupal_not_found();
      return;
    };

     $form['tree_root_data'] = array(
       '#type'  => 'value',
       '#value' => $treemenu['vid'] . ':' . $treemenu['tid'],
     );
     
     $form['display1'] = array(
       '#value' => "<p><b>Treemenu</b> grown from  " . 'Vid: ' . $treemenu['vid'] . ', Tid: '. $treemenu['tid'] . "</p>",
     );

     $form['display2'] = array(
       '#value'  =>  "<p><b>Machine name</b> used for addressing in urls: " . $menu_name . "</p>",
     );

  }
  //dpm($treemenu);
  if (module_exists('dhtml_menu')) {

      $form['dhtml_menu'] = array(
        '#default_value'  => !empty($treemenu['use_dhtml_menu_on_pages']),
        '#title'          => t('Use the DHTML effect on !menu_name pages', array('!menu_name' => $menu_name)),
        '#description'    => t('If you switch this on, then block DHTML is disabled - the DHTML gets confused if two similar menus share the same page. To use the DHTML effect in blocks, see the block configuration pages.'),
        '#type'           => 'checkbox',
       // '#weight'         => -3,
      );

  }

  
  $form['render_options'] = array(
    '#type' => 'fieldset',
    '#title' => t('Treemenu render options'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
    '#description' => t('Treemenu has a special renderer. This is a little slower than core, but adds useful functions for customizing treemenus.'),
  );

      $form['render_options']['node_options'] = array(
        '#type' => 'fieldset',
        '#title' => t('Treemenu node options'),
        '#collapsible' => FALSE,
        '#description' => t('Options to display child nodes, or number of child nodes.'),
      );
      
        $form['render_options']['node_options']['nodes'] = array(
          '#type' => 'checkbox',
          '#title' => t('Show nodes'),
          '#default_value' => $treemenu['nodes'],
          '#description' => t('If showing, node links are always enabled.'),
        );
              
        $form['render_options']['node_options']['leaf_node_count'] = array(
        '#type' => 'checkbox',
        '#title' => t('Add node count to leaf terms'),
        '#default_value' => $treemenu['leaf_node_count'],
        //'#description' => t('If showing, node links are always enabled.'),
        );
    
      $form['render_options']['menu_root_options'] = array(
        '#type' => 'fieldset',
        '#title' => t('Treemenu root link options'),
        '#collapsible' => FALSE,
        '#description' => t('Modify the behaviour of treemenu roots.'),
      );
      
       $form['render_options']['menu_root_options']['link_roots_to_menutrees'] = array(
          '#title' => t('Link treemenus'),
          '#type' => 'checkbox',
          '#default_value' => $treemenu['link_roots_to_menutrees'],
          '#description' => t('If a link in this menu points to another treemenu root, then the link will page the treemenu directly (not page a list of terms or nodes). Only works if the menu is shown in a page.'),
        );      
      /*
      //disabled, for now?
        $form['render_options']['menu_root_options']['root_path'] = array(
          '#type' => 'textfield',
          '#title' => t('Treemenu root path'),   
          '#default_value' => isset($treemenu['root_path']) ? $treemenu['root_path'] : '<root>',
          '#description' => t('The root link of this treemenu can be re-routed to this path. This can be an internal Drupal path or an external URL. Enter %root, the default, to link to the usual taxonomy branch page. Enter a full treemenu node or category link (e.g taxmenu/menu-%title/node/[nid]) to preserve the breadcrumb structure. Useful for providing an instant introduction to one of your menus.', array('%root' => '<root>', '%title' => $treemenu['title'])),
          '#suffix' => '<b>' . t("Note"). '</b>' . t(": 'Treemenu root path' overrides 'Link menutrees' i.e. if a link for %title appears in other treemenus, then that link will go to the 'Menutree root path' link, not page the %title menu.", array('%title' => $treemenu['title'])),
        );

      $form['render_options']['disable_treemenu_links'] = array(
        '#title' => t('Treemenu link state'),
        '#type' => 'radios',
        '#default_value' => $treemenu['disable_treemenu_links'], //($treemenu['disable_treemenu_links'] == 'disabled with roots' || $treemenu['disable_treemenu_links'] == 'disabled') ? 'disabled' : 'enabled',
        '#description' => t('Note: The Drupal "disable link" checkbox removes links - the Treemenu "disable link state" options continue to display the link information, and so the taxonomy structure, but the link becomes a span and so is unusable. Useful for preventing unexpected term paging for the user.'),
        //'#options' => array(t('Enabled'), t('Disabled'), t('Disable, but re-enable root links')),
        '#options' => array( 'enabled' => t('Enabled'), 'disabled' => t('Disabled')),
      );
      //dpm($treemenu['disable_treemenu_links']);
      //this would be more user friendly if we could jquery it against the above, 
      // i.e. if state is disabled, expand the filedset
      $form['render_options']['disable_options'] = array(
        '#type' => 'fieldset',
        '#title' => t('Treemenu disabled options'),
        '#collapsible' => TRUE,
        '#collapsed' => TRUE,
        '#description' => t('Options which apply to disabled menus only.'),
      );
      
          $form['render_options']['disable_options']['enable_root_links'] = array(
            '#title' => t('re-enable root links'),
            '#type' => 'checkbox',
            '#default_value' => $treemenu['enable_root_links'],
          );
          
          $form['render_options']['disable_options']['enable_tree_leaves'] = array(
            '#title' => t('re-enable tree leaves'),
            '#type' => 'checkbox',
            '#default_value' => $treemenu['enable_tree_leaves'],
            '#description' => t("Will enable all terminal links in the menu. Has no effect if 'Show nodes' is checked (see above)."),
          );
  
      */

  $form['depth'] = array(
    '#type' => 'depth',
    '#title' => t('Depth'),
    '#description' => t('...of menu. The tree root will always show.'),
    '#default_value' => $treemenu['depth'], 
  );
 
  //pull in menu_edit_menu_submit()
  require_once(drupal_get_path('module', 'menu') .'/menu.admin.inc');
  $form = array_merge($form, menu_edit_menu($form_state, $type, $treemenu));

  /* Yes we do require these,
  but that requirement will validate
  before the branch selector,
  tripping errors,
  and annoying the user.
  So we'll validate these fields in the function, not automatically.
  */
  $form['title']['#required'] = FALSE;
  $form['menu_name']['#required'] = FALSE;
  
  /* ...but some warning. */
  $form['title']['#title'] .= "<span class=\"form-required\">*</span>";
  $form['menu_name']['#title'] .= "<span class=\"form-required\">*</span>";
  //dpm($treemenu);
  //dpm($form);

  return $form;  
}

function taxonomy_treemenu_edit_menu_change_selector($form, &$form_state) {
    $form_state['rebuild'] = TRUE;
    variable_set('taxonomy_treemenu_selector_is_gui', !(variable_get('taxonomy_treemenu_selector_is_gui', FALSE)));
}

/**
 * Validates the human and machine-readable names when adding or editing a menu.
 */
 //aw, stuff it. A near copy of menu.admin.incs validation.
 //some of this may be depreciated now?
function taxonomy_treemenu_edit_menu_validate($form, &$form_state) {
  $item = $form_state['values'];
  //check there are values at all
  //in title/menuname/hidden variables
  //dpm($item);
  if (strlen(trim($item['menu_name'])) == 0) {
    form_set_error('menu_name', t('The menu name is required.'));
  }
  if (strlen(trim($item['title'])) == 0) {
    form_set_error('title', t('The title name is required.'));
  }
  if ($item['tree_root_display']['tree_root_data'] == '-:-') {
    form_set_error('tree_root_display', t('A branch selection is required.'));
  }
  if ($item['tree_root_data'] == '-:-') {
    form_set_error('tree_root_data', t('A branch selection is required.'));
  } 
  if (preg_match('/[^a-z0-9-]/', $item['menu_name'])) {
    form_set_error('menu_name', t('The menu name may only consist of lowercase letters, numbers, and hyphens.'));
  }
  if (strlen($item['menu_name']) > MENU_MAX_MENU_NAME_LENGTH_UI) {
    form_set_error('menu_name', format_plural(MENU_MAX_MENU_NAME_LENGTH_UI, "The menu name can't be longer than 1 character.", "The menu name can't be longer than @count characters."));
  }
  if ($form['#insert']) {
    // We will add 'menu-' to the menu name to help avoid name-space conflicts.
    $item['menu_name'] = 'menu-'. $item['menu_name'];
    if (db_result(db_query("SELECT menu_name FROM {menu_custom} WHERE menu_name = '%s'", $item['menu_name'])) ||
      db_result(db_query_range("SELECT menu_name FROM {menu_links} WHERE menu_name = '%s'", $item['menu_name'], 0, 1))) {
      form_set_error('menu_name', t('The menu already exists.'));
    }
  }
}


/**
 * Special submit handler calls menu_edit_menu_submit() first,
 * thus creating initial framework,
 * then calls this, which adds submenu data and submenu items.
 */
 // I tried. I tried using hook_form_alter, but its too lightweight. Either it fails to address stuff in other files,
 //loosing callbacks and form elements, or you stick your entire admin in the main file, and have to jiggle like crazy.
 //I tried redirection (drupal_goto) from hook_alter, but once the form handlers have the form, they're off, 
 //and you can't cancel the request, not fully - and you've built a form only to throw it away.
 //I considered a seperate structure, but that would be awful for the user - 'use this form, not this one'. 
  //The current idea is to hijack the menu-edit button by using specific paths, which are built in hook_menu. 
  //This is not elegant, but it effective, and Drupalish.
  //The add 'Add' version gets it's own link, to appear in the menu pages.
  //The end result callbacks here, where we require the menu edit forms.
  //Anyone got any tidier ideas? (We could use file attributes to pull in, and drupal submits, I suppose). 
function taxonomy_treemenu_edit_menu_submit($form, &$form_state) {
  //dpm($form_state);
  //return;
  //pull in menu_edit_menu_submit()
  require_once(drupal_get_path('module', 'menu') .'/menu.admin.inc');
  menu_edit_menu_submit($form, &$form_state);
  
  //restore the relevant variables
  $menu = $form_state['values'];
  if ($form['#insert']) {
    $menu['menu_name'] = 'menu-'. $menu['menu_name'];
  }
  
  //retrieve tree root data
  $tree_root_data = variable_get('taxonomy_treemenu_selector_is_gui', FALSE) ? $menu['tree_root_data'] : $menu['tree_root_display']['tree_root_data'];
  $root_ids = explode(':', $tree_root_data);
  
  //add our extra data...
  $tmd = variable_get('taxonomy_treemenu_data', array());
  
  //Configure root links options
  //if(($menu['disable_treemenu_links'] == 'disabled') && $menu['enable_root_links']) {
    //$menu['disable_treemenu_links'] = 'disabled with roots';
  //}
  //If 'use_dhtml_menu_on_pages' is on then we switch 'use_dhtml_menu_in_blocks'
  // off, or the DHTML gets confused.
  $use_dhtml_in_blocks = ($menu['dhtml_menu']) ? 0 : $tmd[$menu['menu_name']]['use_dhtml_menu_in_blocks'];
  $tmd[$menu['menu_name']] = array(
    'vid'   => $root_ids[0],
    'tid'   => $root_ids[1],
    'depth' => $menu['depth'],
    'nodes' => $menu['nodes'],
    'leaf_node_count' => $menu['leaf_node_count'],
    'use_dhtml_menu_in_blocks' => $use_dhtml_in_blocks ,
    'use_dhtml_menu_on_pages' => $menu['dhtml_menu'],
    'link_roots_to_menutrees' => $menu['link_roots_to_menutrees'],
    'root_path' => $menu['root_path'],
    'options_changed' => 1, 
    );

  //Some backwards compatibility cleanup (V4).
  unset($tmd[$menu['menu_name']]['disable_treemenu_links']);
  unset($tmd[$menu['menu_name']]['enable_root_links']);
  unset($tmd[$menu['menu_name']]['enable_tree_leaves']);
  unset($tmd[$menu['menu_name']]['_disable_branches']);
  unset($tmd[$menu['menu_name']]['_disable_leaves']);

  variable_set('taxonomy_treemenu_data', $tmd);
  //dpm($root_ids[0] .' : '. $root_ids[1].' : '. $menu['menu_name'].' : '. $menu['depth'].' : '. $menu['nodes']);
  //...and build the subtree links
  //taxonomy_treemenu_create_sublinks($root_ids[0], $root_ids[1], $menu['menu_name'], $menu['depth'], $menu['nodes']);
  taxonomy_treemenu_create_sublinks($root_ids[0], $root_ids[1], $menu['menu_name'], $menu['depth']);
  
  //needed for the admin router item to redirect  
  menu_rebuild(); 
}
